% betrift alles claudien:
% fix(_), type(_) etc. aus dem Language file lesen und speichern
%reihenfolge bei gelernten cpd ist wichtig. Was ist hier los?
%aufraeumen des speichers
% welchen Einfluss hat der Threshold auf das lernen?
% reduziere die Zahl der Modelle. Es muessen nur die unterschiedlichen beachtet werden.

%compile('blopconsole.pl')

%--------------------------------------------------------------------------
% BLoP - version 0.2
%
% Kristian Kersting% Albert-Ludwigs-University of Freiburg
% Germany
%
% kersting@informatik.uni-freiburg.de
% Copyright 2001
%--------------------------------------------------------------------------

% No intention of efficient 
% Merely meant as high level code for BLPs
	
:- use_module(library(lists)).
:- use_module(library(ordsets)).
:- use_module(library(charsio)).
:- use_module(library(system)).
:- use_module(library(ugraphs)).
:- use_module(library(terms)).
:- use_module(library(arrays)).
:- use_module(library(random)).
%:- use_module(library(tcltk)).

:- multifile foreign_resource/2.

%:- [blop_netica].
%:- [blop_c].
%:- [engGetRealArray].
%:- [matlab_engine].
%:- [blop_theta].


:- dynamic domain/3, combining_rule/2, api/1, matlab_engine/1.
:- dynamic dot_node/4, blop_running/0, tcl_interpreter/1, netica_equivalence/2.
:- dynamic network/1, evidence/1, bnt_node/4, cpd/4, netica_hash/2.
:- dynamic logical/1, decomposable/1, invented/1, clamped/1, scored_theory/2, top_theories/1.

% NOTE: in a domain specification, true should come before false

:- prolog_flag(redefine_warnings,_,off),	prolog_flag(single_var_warnings,_,off).
:- set_prolog_flag(agc_margin,10).

% possible arguments of matlab_engine are e.g.
% jtree_compiled_inf_engine, var_elim_inf_engine, enumerative_inf_engine

:- op(500,xfy,'|').

%--------------------------------------------------------------------------
%------------------------  the tcltk shell (on top of the text shell)-----------------------
%--------------------------------------------------------------------------




%--------------------------------------------------------------------------
% flip the clamped flag of a Bayesian clause
blop(switch_clamped_status((H|B))) :- !,
  blop(switch_clamped_status,H,B),
  format('Switched clamped status of ~q.| ~q~n',[H,B]),
  blop(next).       

blop(switch_clamped_status(H)) :-
  blop(switch_clamped_status,H,true),
  format('Switched clamped status of ~q.~n',[H]),
  blop(next).

%--------------------------------------------------------------------------
% sampling from the support network ( with and without evidence E)
blop(sample(N,E,H)) :-
	blop(sample,N,E,H,SL),
        remove_invented_nodes_from_list_of_samples(SL,RSL),
	prolog_id(RSL,PSL),
	format('~nSample:~n~q~n~n',[PSL]),
	blop(next).

blop(sample(N,H)) :-
	blop(sample,N,[],H,SL), 
	remove_invented_nodes_from_list_of_samples(SL,RSL),
	prolog_id(RSL,PSL),
	format('~nSample:~n~q~n~n',[PSL]),
	blop(next).

%--------------------------------------------------------------------------
% learning the ml paramteres of the current blp

%--------------------------------------------------------------------------
% em algorithm
blop(em(Datafile,MaxIter,Threshold)) :- 
  blop(em,Datafile,MaxIter,Threshold).

%--------------------------------------------------------------------------
% hill climbing
blop(g(Datafile,Step,MaxIter,Threshold)) :-
  blop(cg,Datafile,Step,MaxIter,Threshold).

%--------------------------------------------------------------------------
% conjugate gradient
blop(cg(Datafile,MaxIter,Threshold)) :-
  blop(cg,Datafile,MaxIter,Threshold).

%--------------------------------------------------------------------------
% scaled conjugate gradoent
blop(scg(Datafile,MaxIter,Threshold)) :-
  blop(scg,Datafile,MaxIter,Threshold).

%--------------------------------------------------------------------------
% structural learning using probabilisitic extension of claudien
blop(claudien(DataFile,LangFile,MaxIter,Threshold)) :-
  blop(claudien,DataFile,LangFile,MaxIter,Threshold).

%--------------------------------------------------------------------------
% query the current blp (evidence E not given and given)
blop((Head;Body)) :- !,
	blop(query,(Head;Body),Marg),
	write(Marg),nl,
	blop(next).

blop(Head) :-
	blop(query,Head,Marg),
	write(Marg),nl,
	blop(next).
%--------------------------------------------------------------------------
% default rule. Fires if non of the other rules have fired
blop(_) :-
	format('Unknown command !~nType ''help.'' to get the list of commands.~n~n',[]),
	blop(next).

%--------------------------------------------------------------------------
% the help comments
blop_help :- !,nl,
	write('   ***********************************************************************'),nl,
	write('   *                BLoP - Bayesian Logic Programs Interpreter           *'),nl,
	write('   ***********************************************************************'),nl,
	write('   * help.                            |+ this message                    *'),nl,
	write('   * Q1,...QN.                        |+ probability density             *'),nl,
	write('   *                                  |  p(Q1,...,QN)                    *'),nl,
	write('   * Q1,...,QN|E1=e1,...,EM=eM.       |+ conditional probability density *'),nl, 
	write('   *                                  |  p(Q1,...,QN|E1=e1,...,EM=eM)    *'),nl,
	write('   * [''nat.blp''].                     |+ consult BLP file ''nat.blp''      *'),nl,
	write('   * save(''nat.blp'').                 |+ save current BLP to ''nat.blp''   *'),nl,	
              write('   * em(''data.blp_data'',10,0.01).     |+ MLE of parameters using EM      *'),nl,  
              write('   * g(''data.blp_data'',1.0,10,0.01).  |+ MLE of parameters using G       *'),nl, 
              write('   * cg(''data.blp_data'',10,0.01).     |+ MLE of parameters using CG      *'),nl, 
              write('   * scg(''data.blp_data'',10,0.01).    |+ MLE of parameters using SCG     *'),nl,
	write('   * api(netica).                     |+ use Netica API to do inference  *'),nl,
	write('   * api(matlab).                     |+ use Matlab API to do inference  *'),nl,
	write('   * matlab_engine(jtree_inf_engine). |+ use jtree_inf_engine within the *'),nl,
	write('   *                                  |  Matlab API to do inference.     *'),nl,
	write('   *                                  |  Other engines are               *'),nl,
	write('   *                                  |    jtree_compiled_inf_engine     *'),nl,
	write('   *                                  |    var_elim_inf_engine,          *'),nl,	
	write('   *                                  |    enumerative_inf_engine.       *'),nl,	
	write('   * exit.                            |+ exit the shell                  *'),nl,
	write('   ***********************************************************************'),nl,nl.

%--------------------------------------------------------------------------
% the prompt used by the text shell 
blop_prompt :-
	write('BLoP ?- '),
	flush_output(user_output).

%--------------------------------------------------------------------------
% --------------------------------- definitions used by both shels -------------------
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% switching the API used for inference etc.
blop(api,netica) :-
	api(netica),!.
blop(api,netica) :-
	api(matlab),
	engClose,
	retractall(api(_)),
	asserta(api(netica)).
blop(api,matlab) :-
	api(matlab),!.
blop(api,matlab) :-
	api(netica),
	retractall(api(_)),
	engOpen,
	asserta(api(matlab)).

%--------------------------------------------------------------------------
% consulting a Bayesian logic program. X is the file name, e.g. 'nat.blp'
blop(consult,X) :- !,
	retractall(clause_counter(_)),
	retractall(domain(_,_,_)),	
              retractall(combining_rule(_,_)),
              retractall(cpd(_,_,_,_)),
	retractall(ref(_,_,_)),
              retractall(clamped(_)),
	retractall(netica_equivalence(_,_)),
	assert(clause_counter(0)),
	consult(X),
%              ground_ext_cpds,
              mk_uniform_cpds,
	      mk_random_cpds,
              mk_cpds_stochastic.

%--------------------------------------------------------------------------
% consulting a language file. X is the language file name 'nat.blp'
blop(lang_consult,X) :- !,
              retractall(clause_counter(_)),
	retractall(extensional(_)), 
              retractall(cpd(_,_,_,_)),
	retractall(domain(_,_,_)),
              retractall(type(_)),			
              retractall(combining_rule(_,_)),
	retractall(ref(_,_,_)),
              retractall(fix(_)),
              retractall(clamped(_)),
	retractall(netica_equivalence(_,_)),
	assert(clause_counter(0)),
	consult(X),
              mk_uniform_cpds,
	       mk_random_cpds,
              mk_cpds_stochastic.

%--------------------------------------------------------------------------
% saving the current bayesian logic program
blop(save,domains) :-
  findall(domain(X,Y,Z),domain(X,Y,Z),L),
  blop(save_list,L).
  
blop(save,logic_program) :-
  findall((H|B),ref(H,B,_),L),
  blop(save_lp,L).

blop(save,cpds) :-
  findall(cpd(H,B,CPD),cpd(H,B,_,CPD),L),
  blop(save_cpds,L).

blop(save,combining_rules) :-
  findall(combining_rule(X,Y),combining_rule(X,Y),L),
  blop(save_list,L).

blop(save_list,[]).
blop(save_list,[X|Xs]) :-
  format('~q.~n',[X]),
  blop(save_list,Xs).

blop(save_lp,[]).
blop(save_lp,[(H|true)|Xs]) :- !,
  format('~q. ~n',[H]),
  blop(save_lp,Xs).
blop(save_lp,[(H|B)|Xs]) :-
  format('~q | ~q. ~n',[H,B]),
  blop(save_lp,Xs).

blop(save_cpds,[]).
blop(save_cpds,[cpd(H,true,CPD)|Xs]) :-!,
  format('cpd(~q,~q). ~n',[H,CPD]),
  blop(save_cpds,Xs).
blop(save_cpds,[cpd(H,B,CPD)|Xs]) :-
  format('cpd((~q | ~q),~q). ~n',[H,B,CPD]),
  blop(save_cpds,Xs).

blop(save,Filename) :-
  tell(Filename),
  format(':-dynamic cpd/4.~n~n',[]),
  blop(save,domains),nl,nl,
  blop(save,logic_program),nl,nl,
  blop(save,cpds),nl,nl,
  blop(save,combining_rules),
  told.

%--------------------------------------------------------------------------
% proceed a probailistic query
blop(query,(Q;E),Marg) :- !,
	conj_2_list(Q,QL),
	conj_2_list(E,EL),
	query(QL,EL,Marg).

blop(query,Q,Marg) :- 
	conj_2_list(Q,QL),
	query(QL,[],Marg).

%--------------------------------------------------------------------------
%switching the flag whether a clause will be clamped or not during MLE of parameters
blop(switch_clamped_status,H,B) :-
  (clamped(cpd(H,B,_,_))->
      (retractall(clamped(cpd(H,B,_,_))));
      (asserta(clamped(cpd(H,B,_,_))))).

%--------------------------------------------------------------------------
% em, scg, cg algorithms
blop(Alg,Datafile,MaxIter,Threshold) :-	
   format('~nCleaning up databse ...~n', []),
  retractall(network(_)),
  retractall(evidence(_)),
  retractall(netica_hash(_,_)),
  retractall(netica_equivalence(_,_)),
  retractall(invented(_)),
  asserta(network([])), 
  format('done.~nReading samples from file ...~n', []),
  read_samples_from_file(Datafile,Samples),
  length(Samples,SaL),
  format('[~q]done.~nComputing relevant random variables...~n',[SaL]),
  variablesCS(Samples,VarUS),
  length(VarUS,VarL),
  format('[~q]done.~nEliminating duplicates ...~n',[VarL]),
  sort(VarUS,Var),
  format('done.~nComputing support network ...~n',[]),
  compute_support_network(Var,SN),
  format('done.~nComputing identifiers...~n',[]),
  netica_id(Samples,HSamples),
  netica_id(SN,HSN),
  format('done.~nEstimating ML paramters ...~n',[]),
  once( (Alg = em ->
   blop_netica_mle_em(HSN,HSamples,MaxIter,Threshold,CPDsID,Score,_);
   Alg = cg ->
   blop_netica_mle_cg(HSN,HSamples,MaxIter,Threshold,CPDsID,Score,_);
   Alg = scg ->
   blop_netica_mle_scg(HSN,HSamples,MaxIter,Threshold,CPDsID,Score,_);
   fail)), 
  prolog_id(CPDsID,CPDs),
  assert_estimated_cpds(CPDs),
  format('done.~nLLog: ~q~n',[Score]).

%--------------------------------------------------------------------------
% hill climbing
blop(g,Datafile,Step,MaxIter,Threshold) :-   
  format('~nCleaning up databse ...~n', []),
  retractall(network(_)),
  retractall(evidence(_)),
  retractall(netica_hash(_,_)),
  retractall(netica_equivalence(_,_)),
  retractall(invented(_)),
  asserta(network([])), 
  format('done.~nReading samples from file ...~n', []),
  read_samples_from_file(Datafile,Samples),
  format('done.~nComputing relevant random variables...~n',[]),
  variablesCS(Samples,VarUS),
  format('done.~nEliminating duplicates ...~n',[]),
  sort(VarUS,Var),
  format('done.~nComputing support network ...~n',[]),
  compute_support_network(Var,SN),
  format('done.~nComputing identifiers...~n',[]),
  netica_id(Samples,HSamples),
  netica_id(SN,HSN),
  format('done.~nEstimating ML paramters ...~n',[]), 
  blop_netica_mle_g(HSN,HSamples,Step,MaxIter,Threshold,CPDsID,_,_),
  prolog_id(CPDsID,CPDs),
  assert_estimated_cpds(CPDs),
  format('done.~nLLog: ~q~n',[Score]).

%--------------------------------------------------------------------------
% sampling from the support network
blop(sample,N,E,H,SL) :-
	network(SN),
	(api(netica)->
	    netica_sample(SN,E,N,H,SL,_);
	    format('~nCurrently not support for Matlab~n',[])).

%--------------------------------------------------------------------------
% probabilistic extension claudien

blop(claudien,DataFile,LanguageFile,MaxIter,Threshold) :-	
	nl, write('Cleaning up database ...'),nl,
	retractall(network(_)),
	retractall(evidence(_)),
	retractall(netica_hash(_,_)),
	retractall(netica_equivalence(_,_)),
	retractall(invented(_)),
	retractall(scored_theory(_,_,_)),
	retractall(top_theories(_)),
	asserta(network([])), 
	write('done.'),nl,
	blop_claudien_start(LanguageFile,DataFile,em,MaxIter,Threshold,LearnedTheory,LearnedCPDs,_),
	retractall(ref(_,_,_)),
	claudien_assert_estimated_cpds(LearnedCPDs,0).

%--------------------------------------------------------------------------
% asserts a learned theory into the prolog database
% There exist two version. One is for paramterestimion only. Here, we do not have to change the structure.
% claudien_assert... is changing the structure as well, i.e. calls like assert(H:-B) are done.

assert_estimated_cpds([]).
assert_estimated_cpds([cpd(decomposed,_)|Xs]) :- !,
  assert_estimated_cpds(Xs).   
assert_estimated_cpds([cpd(ext(_),_)|Xs]) :- !,
  assert_estimated_cpds(Xs).   
assert_estimated_cpds([cpd(R,CPD)|Xs]) :-
  ref(H,B,R), 
  retract(cpd(H,B,BL,_)),
  asserta(cpd(H,B,BL,CPD)),
  assert_estimated_cpds(Xs).

claudien_assert_estimated_cpds([],_).
claudien_assert_estimated_cpds([cpd((H:-true),CPD)|Xs],N) :-
  assert((H:-true)), 
  assert(ref(H,true,N)), 
  NewN is N + 1,
  retractall(cpd(H,B,[],_)),
  asserta(cpd(H,B,[],CPD)),
  claudien_assert_estimated_cpds(Xs,NewN).
claudien_assert_estimated_cpds([cpd((H:-B),CPD)|Xs],N) :- 
  assert((H:-B)), 
  assert(ref(H,B,N)),
  NewN is N + 1,
  conj_2_list(B,BL),
  retractall(cpd(H,B,BL,_)),
  asserta(cpd(H,B,BL,CPD)),
  claudien_assert_estimated_cpds(Xs,NewN).


%--------------------------------------------------------------------------
%---------------------------------------------------------------------------------------
%--------------------------------------------------------------------------
% some auxiliary files for consulting Bayesian logic programs.
% First of all, a simple grammar for sytax conversion is implemented
% unsing term_expansion. Beside this, some additional information is
% stored

term_expansion((Head|Body1,Body2), (Head:-Body1,Body2)).
term_expansion((Head|Body), (Head:-Body)).
term_expansion(domain(A/N,T,D),(:- dynamic A/N)) :-
              retractall(domain(A/N,_,_)),assert(domain(A/N,T,D)).
term_expansion(combining_rule(A/N,B),(:- dynamic A/N)) :-
              retractall(combining_rule(A/N,_)),assert(combining_rule(A/N,B)).
term_expansion(cpd((H|B),CPD),cpd(H,B,BLL,CPD)) :-
	conj_2_list(B,BL),
	remove_logical_ones(BL,BLL),
	clause_counter(C),
	NewC is C + 1,
	assert(ref(H,B,C)),
	retractall(clause_counter(C)),
	assert(clause_counter(NewC)).
term_expansion(cpd(H,CPD),cpd(H,true,[],CPD)) :- !,
	clause_counter(C),
	NewC is C + 1,
	assert(ref(H,true,C)),
	retractall(clause_counter(C)),
	assert(clause_counter(NewC)).

%--------------------------------------------------------------------------
% rewrite a given conjunction as a list
conj_2_list((A,B),L) :-
	conj_2_list(A,LA),
	conj_2_list(B,LB),
	append(LA,LB,L).
conj_2_list((A),[A]).

%--------------------------------------------------------------------------
% ground extensional cpds (if needed)
% sometimes it is nice not to write the cpds for each extensional ground fact but to specifiy
% the same the cpd for all of them. Here, we expand this short-hand notation

ground_ext_cpds :-
  findall(cpd(H,true,[],CPD),cpd(H,true,[],CPD),L), 
  ground_ext_cpds(L).

ground_ext_cpds([]).
 ground_ext_cpds([cpd(H,true,[],_)|CPDs]) :-
  ground(H),!,
  ground_ext_cpds(CPDs).

ground_ext_cpds([cpd(H,true,[],CPD)|CPDs]) :-
  findall(cpd(H,true,[],CPD),(clause(H,true)),L),
  retractall(ref(H,true,_)),
  retractall(cpd(H,true,[],CPD)),
  ground_ext_cpds_asserta(L),  	  
  ground_ext_cpds(CPDs).

ground_ext_cpds_asserta([]).
ground_ext_cpds_asserta([cpd(H,true,[],CPD)|Xs]) :-
  clause_counter(C),
  NewC is C + 1,
  assert(ref(H,true,C)),
  retractall(clause_counter(C)),
  assert(clause_counter(NewC)),
  asserta(cpd(H,true,[],CPD)),
  ground_ext_cpds_asserta(Xs).

%--------------------------------------------------------------------------
% making uniform cpds
% expanding the 'tabular(uniform)' entry in a read in blp to the pure representation [1/n 1/n ... ]
mk_uniform_cpds :-
  findall((R,cpd(H,B,Pa,tabular(uniform))),clause(cpd(H,B,Pa,tabular(uniform)),true,R),L),
  sort(L,SL),
  mk_uniform_cpds(SL).

mk_uniform_cpds([]) :- !.
mk_uniform_cpds([(R,CPD)|CPDs]) :-
  mk_uniform_cpds(CPD,NewCPD),
  erase(R),
  asserta(NewCPD),
  mk_uniform_cpds(CPDs).

mk_uniform_cpds(cpd(H,B,Pa,tabular(uniform)),cpd(H,B,Pa,tabular(UCPD))) :-
  functor(H,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  dim_parents_domain(Pa,DPa),
  N is L* DPa,
  ones(N,CPD), 
  mk_uniform(L,CPD,UCPD,_).

mk_uniform_cpds(Node,true,[],tabular(SCPD)) :- !,
  functor(Node,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  ones(L,CPD), 
  mk_uniform(L,CPD,UCPD,_),
  mk_stochastic(L,UCPD,SCPD,_).

mk_uniform_cpds(Node,Pa,Parents,tabular(SCPD)) :-
  functor(Node,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  conj_2_list(Pa,Parents),
  dim_parents_domain(Parents,DPa),
  N is L* DPa,
  ones(N,CPD), 
  mk_uniform(L,CPD,UCPD,_),
  mk_stochastic(L,UCPD,SCPD,_).


%--------------------------------------------------------------------------
% making random cpds
% expanding the 'tabular(random)' entry in a read in blp to the pure representation [1/n 1/n ... ]
mk_random_cpds :-
  findall((R,cpd(H,B,Pa,tabular(random))),clause(cpd(H,B,Pa,tabular(random)),true,R),L),
  sort(L,SL),
  mk_random_cpds(SL).

mk_random_cpds([]) :- !.
mk_random_cpds([(R,CPD)|CPDs]) :-
  mk_random_cpds(CPD,NewCPD),
  erase(R),
  asserta(NewCPD),
  mk_random_cpds(CPDs).

mk_random_cpds(cpd(H,B,Pa,tabular(random)),cpd(H,B,Pa,tabular(UCPD))) :-
  functor(H,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  dim_parents_domain(Pa,DPa),
  N is L* DPa,
  random_list(N,CPD), 
  mk_stochastic(L,CPD,UCPD,_).

mk_random_cpds(Node,true,[],tabular(SCPD)) :- !,
  functor(Node,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  random_list(L,CPD), 
  mk_stochastic(L,CPD,SCPD,_).

mk_random_cpds(Node,Pa,Parents,tabular(SCPD)) :-
  functor(Node,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  conj_2_list(Pa,Parents),
  dim_parents_domain(Parents,DPa),
  N is L* DPa,
  random_list(N,CPD), 
  mk_stochastic(L,CPD,SCPD,_).

random_list(0,[]).
random_list(N,[R|Rest]) :-
	NewN is N - 1,
	random_list(NewN,Rest),
	random(R).


%--------------------------------------------------------------------------
% computing the dimension of the joint state space of the a set of nodes (the parents are indended) 
% (tabular cpds only!!)
dim_parents_domain([],1).
dim_parents_domain([P|Pa],NewDim) :-
 functor(P,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  dim_parents_domain(Pa,Dim),
  NewDim is L*Dim.

%--------------------------------------------------------------------------
% making sure the cpd of a currently consulted blp are probability distributions (tabular cpds only!!)
mk_cpds_stochastic :-
  findall(cpd(H,B,Pa,tabular(CPD)),cpd(H,B,Pa,tabular(CPD)),L),
  sort(L,SL),
  mk_cpds_stochastic(SL).

mk_cpds_stochastic([]).
mk_cpds_stochastic([CPD|CPDs]) :-
  mk_cpds_stochastic(CPD,NewCPD),
  retract(CPD),
  asserta(NewCPD),
  mk_cpds_stochastic(CPDs).

mk_cpds_stochastic(cpd(H,B,Pa,tabular(CPD)),cpd(H,B,Pa,tabular(SCPD))) :-
  functor(H,Pr,NA),
  domain(Pr/NA,finite,D),
  length(D,L),
  mk_stochastic(L,CPD,SCPD,_).

%--------------------------------------------------------------------------
% Logical predictes are "uninteresting". We can neglect them, i.e.
% we use them for guiding the search
remove_logical_ones([],[]).
remove_logical_ones([A|R], NR) :-
	functor(A,Pr,NAA),
	logical(Pr/NAA),!,
	remove_logical_ones(R,NR).
remove_logical_ones([A|R], [A|NR]) :-
	remove_logical_ones(R,NR).

%--------------------------------------------------------------------------
% A DFS meta interpreter which computes a single
% successful path of the SLD tree desired
prove(true,P,P):- !.
prove((GA,GB),OP,NP) :-
	functor(GA,Pr,NAA),
	logical(Pr/NAA),!,
	call(GA),
	prove(GB,OP,NP).
prove((GA,GB),OP,NP) :- !,
        prove(GA,OP,PA),
        prove(GB,PA,NP).
prove(G,P,P) :-
	functor(G,Pr,NA),
	logical(Pr/NA),!,
	call(G).
prove(G,OP,[G-B-R|P]) :- 
	clause(G,B),        
	prove(B,OP,P),
	ref(G,B,R).

%--------------------------------------------------------------------------
% Find the union of solution graphs. Works like findall/3 as described in Bratko.
% The output is a lexicographical ordered list of all edges from an 'or' node
% to an 'and' node in the union of all needed solutions graphs.
solution_graph([G|Gs],S) :-
%	tell('C:\Dokumente und Einstellungen\Mc Ich kill jeden vi\Eigene Dateien\hiwi jasper\tmp.blop'),
	prove(G,[],P),
	format('proof(~q).~n',[P]),
	fail;
	solution_graph(Gs,S);
	told,
	see('C:\Dokumente und Einstellungen\Mc Ich kill jeden vi\Eigene Dateien\hiwi jasper\tmp.blop'),
	collect(US),
	seen,
	sort(US,S).

collect(L) :-
	(read(proof(X)),!,
	    collect(R),
	    append(X,R,L));
	L=[].

%collect(L) :-
%	retract(proof(X)),!,
%	(X == end,!,L=[];
%	    collect(R),
%	    append(X,R,L)).
%--------------------------------------------------------------------------
% Construct the support network. Here, we gather information about the nodes only. 
support_network([],[]).
support_network([N-Pa-Ref|Es],[(N,[Ref|Refs],T,D,[Clamped|C],[Parents|Pas],[CPD|CPDs])|SN]) :-
	functor(N,P,NA),
	domain(P/NA,T,D),
	cpd(N,Pa,Parents,CPD),
              (clamped(cpd(N,Pa,Parents,CPD))->Clamped=1;Clamped=0),
	support_network(N,Es,Refs,C,Pas,CPDs,Rest),
	support_network(Rest,SN).

support_network(_,[],[],[],[],[],[]).
support_network(N,[N-Pa-Ref|R],[Ref|Refs],[Clamped|C],[Parents|Pas],[CPD|CPDs],Rest) :-
	cpd(N,Pa,Parents,CPD), 
              (clamped(cpd(N,Pa,Parents,CPD))->Clamped=1;Clamped=0),
	support_network(N,R,Refs,C,Pas,CPDs,Rest).
support_network(_,R,[],[],[],[],R).

%--------------------------------------------------------------------------
% Apply the associated combining rules
% A combining rules cr is prolog definition of the 
% form cr(ListOfParents,ListOfCPDs,Parents,CPD). Given
% two set of sets ListOfParents and ListOfCPDs it computes
% the set of Parents Parents and the associated combined
% CPDs CPD.
apply_comb([],[]).
apply_comb([F|Fs],C) :-
  combine(F,CF),
  apply_comb(Fs,CFs),
  append(CF,CFs,C).

combine((N,LR,T,D,Clamped,LPa,LCPDs),List) :- 
  functor(N,P,NA),
  clause(combining_rule(P/NA,CR),_),
  decomposable(CR),!,
  C=..[CR,N,T,D,Clamped,LR,LPa,LCPDs,List],
  call(C).

combine((N,LR,T,D,LClamped,LPa,LCPDs),List) :- 
  functor(N,P,NA),
  clause(combining_rule(P/NA,CR),prot_exc),!,
  C=..[CR,N,T,D,LClamped,LR,LPa,LCPDs,List],
  call(C).

combine((N,LR,T,D,[Clamped|Clampeds],LPa,LCPDs),[(N,R,T,D,Clamped,Pa,CPD)]) :- 
  functor(N,P,NA),
  once(clause(combining_rule(P/NA,CR),_)),
  C=..[CR,LR,LPa,LCPDs,R,Pa,CPD],
  call(C).


%--------------------------------------------------------------------------
% some combining rules /PAL = List of Parents
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% protein exception
% takes the only partial cpd of length 2.
prot_exc(N,T,D,Clamped,RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

prot_exc(N,T,D,ClampedL,RL,PaL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :- 
	get_exception(ClampedL,RL,PaL,CPDL,Clamped,Pa,CPD).

get_exception(_,_,[],_,[],[],[]).
get_exception([C|Cs],[R|Rs],[Pa|Pas],[CPD|CPDs],C,Pa,CPD) :-
	length(Pa,2),!.
get_exception([_|Cs],[_|Rs],[_|Pas],[_|CPDs],C,Pa,CPD) :-
	get_exception(Cs,Rs,Pas,CPDs,C,Pa,CPD).

%--------------------------------------------------------------------------
% the identity
id([R],[Pa],[CPD],R,Pa,CPD).
id([R],[],[CPD],R,[],CPD).

%--------------------------------------------------------------------------
% noisy_or / introduces new type: decomposed

decomposable(noisy_or_binary).
decomposable(noisy_or_binary_dv).

decomposable(noisy_xor_binary).

decomposable(noisy_and_binary).
decomposable(noisy_and_binary_dv).

decomposable(average).
decomposable(average_dv).

decomposable(fct_dv).

%noisy_or

noisy_or_binary(N,T,D,[Clamped],RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

noisy_or_binary(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NodesList,tabular(CPD))|RulesList]) :-
  noisy_or_binary_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,NodesList,RulesList),
  length(NodesList,L),
  Dim is integer(exp(2,L+1)),
  ones(Dim,CPD_tmp),
  mk_logical_or(CPD_tmp,CPD,_).

%noisy or_dv
noisy_or_binary_dv(N,T,D,[Clamped],RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

noisy_or_binary_dv(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NewNodesList,tabular(CPD))|NewRulesList]) :-
  noisy_or_binary_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,NodesList,RulesList),
  length(NodesList,L),
  (L>2->
      noisy_or_divorce(L,L,N,T,D,NodesList,RulesList,NewNodesList,NewRulesList);
      (NewNodesList=NodesList,NewRulesList=RulesList)),
  Dim is integer(exp(2,3)),
  ones(Dim,CPD_tmp),
  mk_logical_or(CPD_tmp,CPD,_).

noisy_or_divorce(2,_,N,T,D,NodeList,RuleList,NodeList,RuleList).
noisy_or_divorce(M,K,N,T,D,
		 [Node1,Node2|NodeListRest],
		 RuleList,
		 NewNodeList,
		 NewRuleList):-
	decomp_rename(K,N,RN),
	NewM is M-1,
	NewK is K+1,
	Dim is integer(exp(2,3)),
	ones(Dim,CPD_tmp),
	mk_logical_or(CPD_tmp,CPD,_),
	noisy_or_divorce(NewM,NewK,N,T,D,
			 [RN|NodeListRest],
			 [(RN,decomposed,T,D,1,[Node1,Node2],tabular(CPD))|RuleList],
			 NewNodeList,
			 NewRuleList).
	


noisy_or_binary_gather_nodes_and_rules(_,_,_,_,_,[],[],[],[],[]).
noisy_or_binary_gather_nodes_and_rules(N,Node,T,D,[Clamped|C],[R|Rs],[Pa|Pas],[CPD|CPDs],
			       [RNode|NodesList],[(RNode,R,T,D,Clamped,Pa,CPD)|RulesList]):-
  decomp_rename(N,Node,RNode), 
  asserta(invented(RNode)),
  NewN is N + 1,
  noisy_or_binary_gather_nodes_and_rules(NewN,Node,T,D,C,Rs,Pas,CPDs,
				 NodesList,RulesList).

% noisy and

noisy_and_binary(N,T,D,[Clamped],RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

noisy_and_binary(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NodesList,tabular(CPD))|RulesList]) :-
  noisy_and_binary_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,NodesList,RulesList),
  length(NodesList,L),
  Dim is integer(exp(2,L+1)),
  ones(Dim,CPD_tmp),
  mk_logical_and(CPD_tmp,CPD,_).


%noisy and dv

noisy_and_binary_dv(N,T,D,[Clamped],RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

noisy_and_binary_dv(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NewNodesList,tabular(CPD))|NewRulesList]) :-
  noisy_and_binary_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,NodesList,RulesList),
  length(NodesList,L),
  (L>2->
      noisy_and_divorce(L,L,N,T,D,NodesList,RulesList,NewNodesList,NewRulesList);
      (NewNodesList=NodesList,NewRulesList=RulesList)),
  Dim is integer(exp(2,3)),
  ones(Dim,CPD_tmp),
  mk_logical_and(CPD_tmp,CPD,_).

noisy_and_divorce(2,_,N,T,D,NodeList,RuleList,NodeList,RuleList).
noisy_and_divorce(M,K,N,T,D,
		 [Node1,Node2|NodeListRest],
		 RuleList,
		 NewNodeList,
		 NewRuleList):-
	decomp_rename(K,N,RN),
	NewM is M-1,
	NewK is K+1,
	Dim is integer(exp(2,3)),
	ones(Dim,CPD_tmp),
	mk_logical_and(CPD_tmp,CPD,_),
	noisy_and_divorce(NewM,NewK,N,T,D,
			 [RN|NodeListRest],
			 [(RN,decomposed,T,D,1,[Node1,Node2],tabular(CPD))|RuleList],
			 NewNodeList,
			 NewRuleList).
	

noisy_and_binary_gather_nodes_and_rules(_,_,_,_,_,[],[],[],[],[]).
noisy_and_binary_gather_nodes_and_rules(N,Node,T,D,[Clamped|C],[R|Rs],[Pa|Pas],[CPD|CPDs],
			       [RNode|NodesList],[(RNode,R,T,D,Clamped,Pa,CPD)|RulesList]):-
  decomp_rename(N,Node,RNode), 
  asserta(invented(RNode)),
  NewN is N + 1,
  noisy_and_binary_gather_nodes_and_rules(NewN,Node,T,D,C,Rs,Pas,CPDs,
				 NodesList,RulesList).

%noisy_xor

noisy_xor_binary(N,T,D,[Clamped],RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

noisy_xor_binary(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NodesList,tabular(CPD))|RulesList]) :-
  noisy_or_binary_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,NodesList,RulesList),
  length(NodesList,L),
  Dim is integer(exp(2,L+1)),
  ones(Dim,CPD_tmp),
  mk_logical_xor(CPD_tmp,CPD,_).

%--------------------------------------------------------------------------
% average

average(N,T,D,[Clamped],RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

average(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NodesList,tabular(CPD))|RulesList]) :-
  average_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,NodesList,RulesList),
  length(NodesList,L),
  average_cpd(L,1,1,D,CPD).


% average dv

average_dv(N,T,D,[Clamped],RL,PAL,CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,1),!,
  id(RL,PAL,CPDL,R,Pa,CPD).


average_dv(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NewNodesList,tabular(CPD))|NewRulesList]) :-
  average_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,NodesList,RulesList),
  length(NodesList,L),
  (L>2->
      average_divorce(2,L,L,N,T,D,NodesList,RulesList,NewNodesList,NewRulesList);
      (NewNodesList=NodesList,NewRulesList=RulesList)),
  NewL is L - 1,
  average_cpd(2,1,NewL,D,CPD).




average_divorce(_,2,_,N,T,D,NodeList,RuleList,NodeList,RuleList).
average_divorce(Step,M,K,N,T,D,
		 [Node1,Node2|NodeListRest],
		 RuleList,
		 NewNodeList,
		 NewRuleList):-
	decomp_rename(K,N,RN),
	NewM is M-1,
	NewK is K+1,
	NextStep is Step + 1,
	Left is 1,
	Right is Step - Left,
	average_cpd(2,Left,Right,D,CPD),
	average_divorce(NextStep,NewM,NewK,N,T,D,
			 [RN|NodeListRest],
			 [(RN,decomposed,T,D,1,[Node1,Node2],tabular(CPD))|RuleList],
			 NewNodeList,
			 NewRuleList).
	



average_gather_nodes_and_rules(_,_,_,_,_,[],[],[],[],[]).
average_gather_nodes_and_rules(N,Node,T,D,[Clamped|C],[R|Rs],[Pa|Pas],[CPD|CPDs],
			       [RNode|NodesList],[(RNode,R,T,D,Clamped,Pa,CPD)|RulesList]):-
  decomp_rename(N,Node,RNode), 
  asserta(invented(RNode)),
  NewN is N + 1,
  average_gather_nodes_and_rules(NewN,Node,T,D,C,Rs,Pas,CPDs,
				 NodesList,RulesList).

average_cpd(N,Left,Right,D,CPD) :-
	cross_product(N,D,C),
	stats(D,C,Left,Right,CPD).

stats(_,[],_,_,[]).
stats(D,[C|Cs],Left,Right,CPD) :-
	new_array(S),
	init_stats(D,S,IS),
	hist_stats(C,IS,H,Left,Right,N),
	array_to_list(H,HL),
	NewN is N* (Left+Right)/2,
	hist_to_prob(HL,NewN,P),
	stats(D,Cs,Left,Right,Ps),
	append(P,Ps,CPD).

hist_to_prob([],_,[]).
hist_to_prob([_-M|R],N,[P|OldP]) :-
	P is M / N,
	hist_to_prob(R,N,OldP).

hist_stats(A-B,S,H,Left,Right,N) :- !,
	aref(A,S,E),
	NewE is E + Left,
	aset(A,S,NewE,TmpH),
	hist_stats(B,TmpH,H,Left,Right,OldN),
	N is OldN + 1.
hist_stats(A,S,H,Left,Right,1) :- !,
	aref(A,S,E),
	NewE is E + Right,
	aset(A,S,NewE,H).
	  

init_stats([],S,S).
init_stats([D|Ds],S,NewS) :-
	aset(D,S,0,TmpS),
	init_stats(Ds,TmpS,NewS).

cross_product(1,D,D).
cross_product(N,D,C) :-
	NewN is N - 1,
	cross_product(NewN,D,SoFarC),
	ord_setproduct(D,SoFarC,C).
		

% fct dv

fct_dv(N,T,D,[Clamped],RL,[PAL],CPDL,[(N,R,T,D,Clamped,Pa,CPD)]) :-
  length(PAL,0),!,
  id(RL,PAL,CPDL,R,Pa,CPD).

fct_dv(N,T,D,Clamped,RL,PAL,CPDL,[(N,R,T,D,0,Pa,CPD)]) :-
  length(PAL,2),!,
  delete_self_recursion(RL,PAL,CPDL,[R],[Pa],[CPD]).

fct_dv(N,T,D,Clamped,RL,PAL,CPDL,[(N,decomposed,T,D,1,NewNodesList,tabular(CPD))|NewRulesList]) :-
  average_gather_nodes_and_rules(0,N,T,D,Clamped,RL,PAL,CPDL,TNodesList,TRulesList),
  delete_short_cpd(N,TNodesList,TRulesList,NodesList,RulesList),
  length(NodesList,L),
  LL is L + 1,
  (L>2->
      average_divorce(2,L,LL,N,T,D,NodesList,RulesList,NewNodesList,NewRulesList);
      (NewNodesList=NodesList,NewRulesList=RulesList)),
  NewL is L - 1,
  average_cpd(2,1,NewL,D,CPD).


delete_self_recursion([],_,_,[],[],[]).
delete_self_recursion([R|RL],[Pa|PAL],[CPD|CPDL],RL,PAL,CPDL):-
	length(Pa,0),!.
delete_self_recursion([R|RL],[Pa|PAL],[CPD|CPDL],[R|NRL],[Pa|NPAL],[CPD|NCPDL]):-
	delete_self_recursion(RL,PAL,CPDL,NRL,NPaL,NCPDL).

delete_short_cpd(N,[M|Nr],[R|Rr],Nr,Rr):-
	arg(1,N,A1),
	arg(1,M,A2),
	A1==A2,!.
delete_short_cpd(N,[M|Nr],[R|Rr],[M|TNr],[R|TRr]):-
	delete_short_cpd(N,Nr,Rr,TNr,TRr).
	



%--------------------------------------------------------------------------
% Building the support network

%--------------------------------------------------------------------------
% getting the variables we have observed (i.e. we discare the observed states)
evidence_variables([],[]).
evidence_variables([V=_|Vs],[V|Vars]) :-
	evidence_variables(Vs,Vars).

%--------------------------------------------------------------------------
%querying the blp
% note that Q and E are lists
query(Q,E,Marg) :- 
	retractall(proof(_)),
	retractall(network(_)),
	retractall(evidence(_)),
	retractall(netica_hash(_,_)),
	retractall(netica_equivalence(_,_)),
	retractall(invented(_)),
	asserta(proof([])),
	asserta(evidence(E)),
	evidence_variables(E,EVars),
	append(Q,EVars,Vars),
	solution_graph(Vars,S),
	(S==[]->
	    Marg=[];
	    (support_network(S,SNC),
		apply_comb(SNC,SN), 
	     asserta(network(SN)),
	     (api(netica)->
	      (netica_id(SN,HSN),
	       netica_id(Q,HQ), 
	       netica_id(E,HE),
	      blop_netica_inference(HSN,HQ,HE,Marg,_)
	      );
	      query_bnt(SN,Q,E,Marg)))).

%--------------------------------------------------------------------------
% Computation of the support network only. No inference nor similar things.
compute_support_network(RV,SN) :- !,
	retractall(proof(_)),
	retractall(network(_)),
	retractall(netica_equivalence(_,_)),
	retractall(invented(_)),
	assert(proof([])),
	solution_graph(RV,S),
	support_network(S,SNC),
	apply_comb(SNC,SN). 
%	asserta(network(SN)).

%--------------------------------------------------------------------------
% Computation of the support network over the least Herbrand base
compute_LH_support_network(SN) :-
  findall(H,(ref(H,_,_),call(H)),L),
  compute_support_network(L,SN).

% --------------------------------------------------------------------------
% --------------------------- Claudien Learning ---------------------------------
% --------------------------------------------------------------------------

% --------------------------------------------------------------------------
% extracting the "logical" models from a set of data cases
extract_models(DataCases,Models) :-
  extract_all_models(DataCases,Unsorted_Models),
  sort(Unsorted_Models,Models).

extract_all_models([],[]).
extract_all_models([Case|Cases],[Model|Models]) :-
  evidence_variables(Case,Unsorted_Model),
  sort(Unsorted_Model,Model),
  extract_all_models(Cases,Models).


% --------------------------------------------------------------------------
% extracting those clauses which are (logically valid) on the data
extract_blop_trueclauses([],_,[]).
extract_blop_trueclauses([C|Cs],Models,[C|TCs]) :-
  blop_trueclause(C,Models),!,
  extract_blop_trueclauses(Cs,Models,TCs).
extract_blop_trueclauses([_|Cs],Models,TCs) :-
  extract_blop_trueclauses(Cs,Models,TCs).

% --------------------------------------------------------------------------
% check whether a set of clauses is valid on a given set of models
blop_truetheory([], Models).
blop_truetheory([C|Cs], Models) :-
	blop_trueclause(C,Models),
	blop_truetheory(Cs, Models).

true_body_single_model((H:-(B1,B2)),Model,NewL) :-
    findall(H,member(B1,Model),L),
    true_body_single_model((H:-B2),Model,LL),
    append(L,LL,NewL).
true_body_single_model((H:-B),Model,L) :-
    findall(H,member(B,Model),L).

blop_trueclause_single_model((H:-true),Model) :-
   member(H,Model),!.

blop_trueclause_single_model((H:-B),Model) :-
  conj_2_list(B,L),
  findall(1,subset(L,Model),LB),
  (LB \= []->(
	      findall(H,subset(L,Model),LB2),
	      (subset(LB2,Model)->
		  true;
		  fail));
      true).

%blop_trueclause_single_model((H:-B),Model) :-
%  conj_2_list(B,L),
%  findall(H,subset(L,Model),LB),
%  LB \= [],
%  subset(LB,Model).

blop_trueclause(C, Models) :-
	C=(H:-B),
	conj_2_list(B,L),
	findall(1,(member(M,Models),subset(L,M)),LB),
	LB\==[],
	blop_realtrueclause(C, Models).

blop_realtrueclause(_, []).
blop_realtrueclause(C, [Model|Models]) :-
	blop_trueclause_single_model(C,Model), 
	blop_realtrueclause(C, Models).

blop_truebody(_,[]).
blop_truebody(B,[Model|Models]):-
	blop_truebody_single_model(B,Model), 
	blop_truebody(B, Models).

blop_truebody_single_model(B,Model) :-
	conj_2_list(B,L),
	findall(H,subset(L,Model),LB),
	LB \= [].



% --------------------------------------------------------------------------
% check whether a given support network is acylic or not
acyclic(SN) :-
	graph(SN,G),!,
	top_sort(G,_).

graph([],[]).
graph([(N-P-_)|R],G) :-
	graph(R,Gtmp),
	my_add_edges(Gtmp,N,P,G).

my_add_edges(G,_,true,G).
my_add_edges(G1,N,(P,Ps),G3) :- !,
	my_add_edges(G1,N,Ps,G2),
	add_edges(G2,[N-P],G3).
my_add_edges(G1,N,P,G2) :- !,
	add_edges(G1,[N-P],G2).
% --------------------------------------------------------------------------
% given a set of intensional rules and a set of data cases, build up a 
% (possibly cyclic) Bayesian network
build_bn_from_data_cases(IDB,BN) :- 
	models(Models),
	families(IDB,0,Models,[],BNtemp),
	roots(Models,0,BNtemp,BNtmp),
	sort(BNtmp,BN).

% compute the ground instances of all applicable intensional rules
families([],_,_,BN,BN).
families([C|Cs],R,Models,OBN,NBN):-
	C=(H:-B),
	copy_term((H:-B),(H1:-B1)),
	findall(H2-B2-R,valid_ground_rule((H1:-B1),Models,(H2:-B2)),BNtmp),
	append(OBN,BNtmp,BNtmp1),
	sort(BNtmp1,BNtmp2),
	NR is R + 1,
	families(Cs,NR,Models,BNtmp2,NBN).


valid_ground_rule((H:-B),Models,(H2:-B2)):-
     member(Model,Models),
     copy_term((H:-B),(H1:-B1)),
     valid_conjunction(B1,Model,B2),
     valid_conjunction(H1,Model,H2).

valid_conjunction(_,[],_).
valid_conjunction((C1,C2),Model,(C1,B2)) :- !,
	member(C1,Model),
	valid_conjunction(C2,Model,B2).
valid_conjunction(C,Models,C) :- 
	valid_literal(C,Models).

valid_literal(L,Model) :- 
	member(L,Model).

%families([],_,_,BN,BN).
%families([(H:-B)|Cs],R,Models,OBN,NBN):-
%	findall(H-B-R,((valid_conjunction(B,Models)->
%		       valid_conjunction(H,Models);fail)),
%		BNtmp),
%	append(OBN,BNtmp,BNtmp1),
%	NR is R + 1,
%	families(Cs,NR,Models,BNtmp1,NBN).

%valid_conjunction(_,[]).
%valid_conjunction((C1,C2),Models) :- !,
%	valid_literal(C1,Models),
%	valid_conjunction(C2,Models).
%valid_conjunction(C,Models) :- 
%	valid_literal(C,Models).

%valid_literal(_,[]).
%valid_literal(L,[Model|Models]) :- 
%	member(L,Model),
%	valid_literal(L,Models).
% --------------------------------------------------------------------------
% compute the apriori nodes of a support network
roots([],_,BN,BN).
roots([Model|Models],N,BN,NewBN) :-
  roots_single_model(Model,N,BN,BN1),
  roots(Models,N,BN1,NewBN).

roots_single_model([],_,BN,BN).
roots_single_model([M|Ms],N,BN,NewBN) :- 
	member(M-_-_,BN),!,
	roots_single_model(Ms,N,BN,NewBN).
roots_single_model([M|Ms],N,BN,NewBN) :- !,
	NN is N + 1,
	R =..['ext',N],
	roots_single_model(Ms,NN,[M-true-R|BN],NewBN).

% --------------------------------------------------------------------------
% construct a support network from a set of samples.  All cpds of not-fixed predicates are uniformly distributed
uniform_support_network([],[]).
uniform_support_network([N-Pa-Ref|Es],[(N,[Ref|Refs],T,D,[Clamped|C],[Parents|Pas],[CPD|CPDs])|SN]) :-
	functor(N,P,NA),
	fix(P/NA),
	cpd(N,Pa,Parents,CPD),!,	
	domain(P/NA,T,D),
	Clamped = 1,
	uniform_support_network(N,Es,Refs,C,Pas,CPDs,Rest),
	uniform_support_network(Rest,SN).
uniform_support_network([N-Pa-Ref|Es],[(N,[Ref|Refs],T,D,[Clamped|C],[Parents|Pas],[CPD|CPDs])|SN]) :-
	functor(N,P,NA),
	domain(P/NA,T,D),
	mk_random_cpds(N,Pa,Parents,CPD),
	(clamped(cpd(N,Pa,Parents,CPD))->Clamped=1;Clamped=0),
	uniform_support_network(N,Es,Refs,C,Pas,CPDs,Rest),
	uniform_support_network(Rest,SN).

uniform_support_network(_,[],[],[],[],[],[]).
uniform_support_network(N,[N-Pa-Ref|R],[Ref|Refs],[Clamped|C],[Parents|Pas],[CPD|CPDs],Rest) :-	
	functor(N,P,NA),
	fix(P/NA),
	cpd(N,Pa,Parents,CPD),!,
	domain(P/NA,T,D),	
	Clamped = 1,
  	uniform_support_network(N,R,Refs,C,Pas,CPDs,Rest).
uniform_support_network(N,[N-Pa-Ref|R],[Ref|Refs],[Clamped|C],[Parents|Pas],[CPD|CPDs],Rest) :-
	mk_random_cpds(N,Pa,Parents,CPD), 
	(clamped(cpd(N,Pa,Parents,CPD))->Clamped=1;Clamped=0),
	uniform_support_network(N,R,Refs,C,Pas,CPDs,Rest).
uniform_support_network(_,R,[],[],[],[],R).

% --------------------------------------------------------------------------
% building a support network from a set of data cases
build_sn_from_data_cases(IDB,SN) :- 
  build_bn_from_data_cases(IDB,ST),!,
  sort(ST,S),
  (acyclic(S) -> 
   (uniform_support_network(S,SNC),
    apply_comb(SNC,SN));
     SN=[]).	  

% --------------------------------------------------------------------------
%score support network using em
netica_score(Theory,Score,CPDs) :-
  retractall(netica_hash(_,_)),
  retractall(ref(_,_,_)),
  retractall(netica_equivalence(_,_)),
  retractall(invented(_)),
  netica_data_cases(HDataCases),
  assert_refs_theory(Theory,0),
  build_sn_from_data_cases(Theory,SN),
  (SN \=[] -> (  
		format('|-->Scoring theory ~q~n',[Theory]),
		netica_id(SN,HSN),
		score_MaxIter(MaxIter),
		score_Threshold(Threshold),
		score_Algorithm(Alg),
		(Alg = em ->
		    blop_netica_mle_em(HSN,HDataCases,MaxIter,Threshold,CPDsID,Score,_);
		    Alg = cg ->
		    blop_netica_mle_cg(HSN,HDataCases,MaxIter,Threshold,CPDsID,Score,_);
		    Alg = scg ->
		    (blop_netica_mle_scg(HSN,HDataCases,MaxIter,Threshold,CPDsID,TScore,_),Score is -1.0*TScore);
		    fail),
		format('|-->Score ~q~n',[Score]),
		prolog_id(CPDsID,RCPDs),
		associate_clauses(RCPDs,CPDs)
	      );
      (
	format('|-->Theory ~q is illegal !!!~n',[Theory]),
      Score = -10000000000.0)). 

% --------------------------------------------------------------------------
% given a set of cpds learned by Netica, we find those rules which correspond to them
associate_clauses([],[]).
associate_clauses([cpd(ext(_),CPD)|Rest],ACPDs) :- !,
  associate_clauses(Rest,ACPDs).
associate_clauses([cpd(decomposed,CPD)|Rest],ACPDs) :- !,
  associate_clauses(Rest,ACPDs).
associate_clauses([cpd(N,CPD)|Rest],[cpd((H:-B),CPD)|ACPDs]) :-
  ref(H,B,N),
  associate_clauses(Rest,ACPDs).

assert_refs_theory([],N).
assert_refs_theory([(H:-B)|Rest],N) :-
  assert(ref(H,B,N)),
  NewN is N + 1,
  assert_refs_theory(Rest,NewN).


% --------------------------------------------------------------------------
% --------------------------------------------------------------------------
% basic claudien stuff
% --------------------------------------------------------------------------
% --------------------------------------------------------------------------
% Note tmp_fix wegen David

% --------------------------------------------------------------------------
% find a toptheory, i.e. given true, find all refinements which are are valid on the data and which are rangerestricted
blop_toptheory([Clause]) :-
	type(Lit),
	functor(Lit,P,N),
	\+ extensional(P/N),
	\+ fix(P/N),
	\+tmp_fix(P/N),
	functor(Head,P,N),
	thetarefine((Head :- true), (H :- L) ),
	(\+ \+ rangerestricted(( H:- L)) ->  Clause = (H :- L) ;
		thetarefine((H :-L), (H1 :- L1)),
		\+ \+ rangerestricted((H1 :- L1) ),  Clause = (H1 :- L1)
		).

%blop_toptheory(_) :-
%	type(Lit),
%	functor(Lit,P,N),
%	\+ extensional(P/N),
%	\+ fix(P/N),
%	\+tmp_fix(P/N),
%	functor(Head,P,N),
%	blop_claudien_theory((Head :- true),3),
%	fail.
%blop_toptheory(Theory) :-
%	findall(C,theory(C),Theory),


blop_claudien_toptheory(T) :-
	models(M),
	findall(C,blop_toptheory([C]),SC),
	blop_claudien_toptheory(SC,M,[],T).

blop_claudien_toptheory([],_,T,T).
blop_claudien_toptheory([(H:-B)|SC],M,OT,NT) :-
	\+ member((H:-_),OT),
	blop_truetheory([(H:-B)|OT],M),
	build_sn_from_data_cases([(H:-B)|OT],SN),
	SN \=[],
	blop_claudien_toptheory(SC,M,[(H:-B)|OT],NT).
blop_claudien_toptheory([_|SC],M,OT,NT) :-
	blop_claudien_toptheory(SC,M,OT,NT).


blop_claudien_theory(Clause,Maxdepth) :-
	Maxdepth > 0, 
	thetarefine(Clause, Clause2),
	Max1 is Maxdepth - 1,
	models(Models),
	\+ \+ (Clause2 = (_ :- B), blop_truebody(B,Models)),
	\+ \+ rangerestricted(Clause2 ),
	(\+ \+ blop_trueclause( Clause2,Models), bodymin(Clause2) ->
	    assert(theory(Clause2)), write(Clause2), nl ;
	    claudien(Clause2, Max1)).

bodymin((H :- B)) :-
	deleteof(_,B,NB),
	models(Models),
	\+ \+  blop_trueclause((H :- NB),Models),
	! ,
	fail.
bodymin((_ :- _)).

% --------------------------------------------------------------------------
% structural learning using a probabilisitc extension of claudien
% the praemble specifies the language, i.e. the Bayesian predicates,
% their domains and the combining rules associated to them

blop_claudien_start(Praemble,DataCases,LearnedTheory,LearnedCPDs,Score) :-
	retractall(data_cases(_)),
	retractall(netica_data_cases(_)),
	retractall(models(_)),
	retractall(top_theories(_)),
	blop(lang_consult,Praemble),
	(atom(DataCases)->
	    ( format('Formatting data cases ...~n',[]),
		read_samples_from_file(DataCases,Examples),
		netica_id(Examples,HDataCases),
		format('done.~nExtracting (logical) models ...~n',[]),
		extract_models(Examples,Models),
		asserta(models(Models)),
		format('done.~n',[]));
	    netica_id(DataCases,HDataCases),
	    format('Extracting (logical) models ...~n',[]),
	    extract_models(DataCases,Models),
	    asserta(models(Models)),
	    format('done.~n',[])),
	asserta(netica_data_cases(HDataCases)),
	blop_claudien(LearnedTheory,LearnedCPDs,Score), 
	retractall(netica_data_cases(_)),
	retractall(data_cases(_)).


blop_claudien_start(Praemble,DataCases,Algorithm,MaxIter,Threshold,LearnedTheory,LearnedCPDs,Score) :-
	retractall(score_MaxIter(_)),
	retractall(score_Threshold(_)),
	retractall(score_Algorithm(_)), 
	retractall(data_cases(_)),
	retractall(netica_data_cases(_)),  
	retractall(models(_)),
	retractall(top_theories(_)),
	asserta(score_MaxIter(MaxIter)),
	asserta(score_Threshold(Threshold)),
	asserta(score_Algorithm(Algorithm)),
	blop(lang_consult,Praemble),   
	(atom(DataCases)->
	    ( format('Formatting data cases ...~n',[]),
		read_samples_from_file(DataCases,Examples),
		netica_id(Examples,HDataCases),
		format('done~n.Extracting (logical) models ...~n',[]),
		extract_models(Examples,Models),
		asserta(models(Models)),
		format('done.~n',[]));
	    netica_id(DataCases,HDataCases),
	    format('Extracting (logical) models ...~n',[]),
	    extract_models(DataCases,Models),
	    asserta(models(Models)),
	    format('done.~n',[])), 
	asserta(netica_data_cases(HDataCases)), 
	blop_claudien(LearnedTheory,LearnedCPDs,Score),
	retractall(netica_data_cases(_)),
	retractall(data_cases(_)).

% --------------------------------------------------------------------------
% find all fixed definitions
fixed_definitions(F) :-
  findall((H:-(B)),(ref(H,B,_),functor(H,P,N),fix(P/N)),F).

% --------------------------------------------------------------------------
% refine a theory I have adapted Lucs version


refinetheory(Theory,[C2 | Theory2]) :-
  theta_delete(C, Theory, Theory2),
  C = (H :- B),
  functor(H,P,N),
  \+ fix(P/N),\+extensional(P/N), 
  \+ tmp_fix(P/N),
  thetarefine(C,C2),
  C2 = (H2 :- B2),
  once(conj_2_list(B2,BL)),
  length(BL,L),
  L < 5.

refinetheory(Theory,Theory2) :-
	type(Lit),
	functor(Lit,P,N),
	\+ extensional(P/N),
	\+ fix(P/N),
	functor(Head,P,N),
	thetarefine((Head :- true), (H :- L) ),
	(\+ \+ rangerestricted(( H:- L)) ->  Clause = (H :- L) ;
		thetarefine((H :-L), (H1 :- L1)),
		\+ \+ rangerestricted((H1 :- L1) ),  Clause = (H1 :- L1)
		),
	append([Clause],Theory,Theory2U),
	sort(Theory2U,Theory2).
%refinetheory(Theory,[C | Theory]) :-
%  top_theories(TT),
%  member([C],TT),
%  C = (H :- B),
%  functor(H,P,N),
%  \+ fix(P/N),\+extensional(P/N),
%   \+ tmp_fix(P/N),
%  functor(H2,P,N),
%  \+ member((H2 :- _), Theory),
%  once(conj_2_list(B,BL)),
%  length(BL,L),
%  L < 4.

my_member(T,[B|Ts]) :-
	subsumes_chk(T,B),
	subsumes_chk(B,T),!.
my_member(T,[_|Ts]) :-
	my_member(T,Ts).

my_sort([],[]).
my_sort([T|Ts],NewTs) :-
	my_sort(Ts,NTs),
	(my_member(T,NTs)->NewTs=NTs;NewTs=[T|NTs]).



% --------------------------------------------------------------------------
% top definition to do structure learning of BLPs
blop_claudien(NewMT,NewCPDs,NewLL) :- 
	format('|-->Finding all top theories ... ',[]),
	fixed_definitions(F),
	models(Models),  
	findall(T,(blop_toptheory(T),once(blop_truetheory(T,Models))),TT),
	asserta(top_theories(TT)),
%	findall(L,(member(T,TT),append(T,F,L)),TL),
	blop_claudien_toptheory(TL), %
	format('done.~n|-->Scoring all top theories...~n',[]), 
	maximally_scored_theory([TL],MT,CPDs,LL),   
	format('|-->done.~n|~n|-->Maximally scored top theory:~n|-->~q~n|-->Score: ~q~n',[MT,LL]),
	blop_claudien(MT,CPDs,LL,NewMT,NewCPDs,NewLL),   
	format('PROBABILISTIC SOLUTION scored ~q~n~q~n',[NewLL,NewMT]).  

	
blop_claudien(MT,CPDs,LL,NewMT,NewCPDs,NewLL) :-
	format('|~n|-->Current hypothesis:~n|--> ~q~n|-->Score: ~q~n|~n|-->Refining...~n',[MT,LL]), 
	models(Models),
	findall(RT,(refinetheory(MT,RT),once(blop_truetheory(RT,Models))),URTL),
	my_sort(URTL,RTL),
	maximally_scored_theory(RTL,MRT,RCPDs,MRLL),   
	findall(GT,(generalizetheory(MT,GT),once(blop_truetheory(GT,Models))),UGTL),
	my_sort(UGTL,GTL),
	maximally_scored_theory(GTL,MGT,GCPDs,MGLL),
	(MGLL>=MRLL ->
	    (NMT=MGT,NLL=MGLL,NCPDs=GCPDs);
	    (NMT=MRT,NLL=MRLL,NCPDs=RCPDs)),
	format('|~n|-->Maximally scored refined theory:~n|-->~q~n|-->Score: ~q~n|~n',[NMT,NLL]),
	(NLL>LL ->
	    blop_claudien(NMT,NCPDs,NLL,NewMT,NewCPDs,NewLL);
	    (NewMT=MT,NewLL=LL,NewCPDs=CPDs)).

% --------------------------------------------------------------------------
% Finde that refined hypothesis which is maximally scored
maximally_scored_theory([],[],_,-10000000000000).
maximally_scored_theory([T|Ts],MT,CPDs,LL) :-	
	netica_score(T,L2,TCPDs),
	maximally_scored_theory(Ts,M,MCPDs,L1),
	(L2>L1->
	    (MT=T,LL=L2,CPDs=TCPDs);
	    (MT=M,LL=L1,CPDs=MCPDs)).


% --------------------------------------------------------------------------
% --------------------------------------------------------------------------
% --------------------------------------------------------------------------
% other stuff like sampling etc.
% --------------------------------------------------------------------------
% --------------------------------------------------------------------------
% --------------------------------------------------------------------------

% Sampling NSamples samples (Hidden% hidden) from a support network SN, given the evidence Evd.
% (Attention: we use netica to do this
netica_sample(SN,E,NSamples,Hidden,SampleList) :-
	netica_id(SN,HSN),
	netica_id(E,HE),
	blop_netica_sample(HSN,HE,NSamples,Hidden,SL,_),
	remove_invented_nodes_from_list_of_samples(SL,RSL),
	prolog_id(RSL,SampleList).

remove_invented_nodes_from_list_of_samples([],[]).
remove_invented_nodes_from_list_of_samples([S|Ss],[RS|RSs]) :-
   remove_invented_nodes_from_sample(S,RS),
   remove_invented_nodes_from_list_of_samples(Ss,RSs).   

remove_invented_nodes_from_sample([],[]).
remove_invented_nodes_from_sample([N=_|Ss],RSs) :-
   prolog_id(N,PN),
   invented(PN),!,
   remove_invented_nodes_from_sample(Ss,RSs).
remove_invented_nodes_from_sample([S|Ss],[S|RSs]) :-
   remove_invented_nodes_from_sample(Ss,RSs).


%--------------------------------------------------------------------------
% writing a list of data cases to a file 

%--------------------------------------------------------------------------
% tcl part interface
tcl_write_samples_to_file([],_,_).
tcl_write_samples_to_file(Samples,Filename,N):-
	tcl_interpreter(Interp),
	tell(Filename),
	tcl_write_samples(Samples,N,Interp),
	told.
tcl_write_samples([],_,_).
tcl_write_samples([Sample|Samples],N,Interp) :-
	format('beginDataCase.~n',[]), !,
	write_sample_to_file(Sample),
	tcl_eval(Interp, [chars("set samples_written"), write(N)],_),
	tcl_eval(Interp, chars("update"),_),
	NewN is N + 1,
	tcl_write_samples(Samples,NewN,Interp).

%--------------------------------------------------------------------------
% the actual writing of the samples
write_samples_to_file([],_).
write_samples_to_file(Samples,Filename):-
	tell(Filename),
	write_samples_to_file(Samples),
	told.

write_samples_to_file([]).
write_samples_to_file([Sample|Samples]) :-
	format('beginDataCase.~n',[]), !,
	write_sample_to_file(Sample),
	write_samples_to_file(Samples).
	
write_sample_to_file([]) :- !,
	format('endDataCase.~n~n',[]).
write_sample_to_file([Var='?'|States]) :-!,
	format('~q=\'~q\'.~n',[Var,'?']),
	write_sample_to_file(States).
write_sample_to_file([State|States]) :-
	format('~q.~n',[State]),
	write_sample_to_file(States).

%--------------------------------------------------------------------------
% reading in a file storing a set of data cases / samples
read_samples_from_file(Filename,Samples) :-
	see(Filename),
	read_samples_file(Samples),
	seen.

read_samples_file(Samples) :- 
	read(Entry),
	read_samples_file(Entry,Samples).
read_samples_file(beginDataCase,[Sample|Samples]) :- !,
	read_sample_file(Sample),
	read_samples_file(Samples).
read_samples_file(end_of_file,[]) :- !.

read_sample_file(Sample) :-
	read(Entry),
	(Entry==endDataCase->Sample=[];
	    (read_sample_file(Samples),
		Sample=[Entry|Samples])).

% ----------------------------------------------------------------------------
% Evaluating a query in matlab using the BN toolbox by Kevin Murphy.
query_bnt(L,Q,E,Marg) :-
	retractall(bnt_node(_,_,_,_)),
	length(L,N),
	engEvalFormat('clear all;~n',[]),
	engEvalFormat('N=~d;~ndag=zeros(N,N);~n',[N]),
	query_bnt_mapping(L,1),
	query_bnt_dag(L),
	bnt_node_info(L,NS,DN,Equi),
	engEvalFormat('ns=~q;~ndnodes=~q;~ne=~q;~nbnet = mk_bnet(dag,ns,dnodes,e);~n',[NS,DN,Equi]),
             query_bnt_potential(L),
	matlab_engine(Engine),
	engEvalFormat('engine = ~q(bnet);~n',[Engine]),
	engEvalFormat('evidence = cell(1,N);~n',[]),
	query_bnt_evidence(E),
	engEvalFormat('engine = enter_evidence(engine, evidence);~n',[]),
	engEvalFormat('marg = marginal_nodes(engine, [~@]);~n',[write_bnt_query_vars(Q)]),
	engEvalFormat('fmarg=blop_pumpup_marginal(marg, evidence, ns, []);~n',[]),
	engEvalFormat('marginal=reshape(fmarg.T,1,prod(size(fmarg.T)));~n',[]),
	engGetRealArray("marginal",Marg).
	
query_bnt_evidence([]).
query_bnt_evidence([E=S|Es]) :-
	bnt_node(E,EN,_,_),
	engEvalFormat('evidence{~q} = ~@;~n',[EN, write_bnt_nth_delement(E,S)]),
	query_bnt_evidence(Es).

query_bnt_potential([]).
query_bnt_potential([(N,_,finite,_,Clamped,[],tabular(CPD))|Ns]) :- !,
	bnt_node(N,NN,_,_),
	engEvalFormat('bnet.CPD{~d}=tabular_CPD(bnet,~d,''CPD'',~q,''clamp'',~q);~n',[NN,NN,CPD,Clamped]),
	query_bnt_potential(Ns).
query_bnt_potential([(N,_,finite,_,Clamped,_,tabular(CPD))|Ns]) :- !,
	bnt_node(N,NN,_,_),
	engEvalFormat('CPD = reshape(~q,ns(family(bnet.dag,~d)));~n',[CPD,NN]),
	engEvalFormat('s   = 1:length(size(CPD));~n',[]),
	engEvalFormat('CPD = permute(CPD,[s(end) s(1:end-1)]);~n',[]),
	engEvalFormat('bnet.CPD{~d}=tabular_CPD(bnet,~d,''CPD'',CPD,''clamp'',~q);~n',[NN,NN,Clamped]),
	query_bnt_potential(Ns).

query_bnt_dag([]).
query_bnt_dag([(N,_,_,_,Pa,_)|Ns]) :-
	query_bnt_edges(N,Pa),
	query_bnt_dag(Ns).

query_bnt_edges(_,[]).
query_bnt_edges(N,[P|Ps]) :-
	bnt_node(N,NN,_,_),
	bnt_node(P,PN,_,_),
	engEvalFormat('dag(~q,~q)=1;~n',[PN, NN]),
	query_bnt_edges(N,Ps).
	
query_bnt_mapping([],_).
query_bnt_mapping([(N,Ref,_,_,_,_)|Ns],C) :-
	(bnt_node(_,E,Ref,_);E=C),
	assertz(bnt_node(N,C,Ref,E)),
	engEvalFormat('~@=~q;~n',[write_no_brackets(N),C]),
	NewC is C + 1,
	query_bnt_mapping(Ns,NewC). 

% ----------------------------------------------------------------------------
% Writing a matlab file encoding the support network and the query.
% The BN toolbox (by Kevin Murphy) is used.
write_bnt(L,Q,E) :-
	retractall(bnt_node(_,_,_,_)),
	length(L,N),
	format('N=~d;~ndag=zeros(N,N);~n~n',[N]),
	write_bnt_mapping(L,1),
	write_bnt_dag(L),
	bnt_node_info(L,NS,DN,Equi),
	format('~nns=~q;~ndnodes=~q;~ne=~q;~nbnet = mk_bnet(dag, ns, dnodes,e);~n~n',[NS,DN,Equi]),
              write_bnt_potential(L),
	matlab_engine(Engine),
	format('engine = ~q(bnet);~n~n',[Engine]),
	format('evidence = cell(1,N);~n',[]),
	write_bnt_evidence(E),
	format('~nengine = enter_evidence(engine, evidence);~n~n',[]),
	format('marg = marginal_nodes(engine, [~@]);~n',[write_bnt_query_vars(Q)]),
	format('fmarg=blop_pumpup_marginal(marg, evidence, ns, []);~n',[]),
	format('marginal=reshape(fmarg.T,1,prod(size(fmarg.T)));~n',[]).

write_bnt_query_vars([]).
write_bnt_query_vars([Q|Qs]) :- 
	bnt_node(Q,QN,_,_),
	write(QN),write(' '),
	write_bnt_query_vars(Qs).	

write_bnt_evidence([]).
write_bnt_evidence([E=S|Es]) :- !,
	bnt_node(E,EN,_,_),
	format('evidence{~q} = ~@;~n',[EN, write_bnt_nth_delement(E,S)]),
	write_bnt_evidence(Es).

write_bnt_potential([]).
write_bnt_potential([(N,_,finite,_,Clamped,[],tabular(CPD))|Ns]) :- !,
	bnt_node(N,NN,_,_),
	format('bnet.CPD{~d}=tabular_CPD(bnet,~d,''CPD'',~q,''clamp'',~q);~n',[NN,NN,CPD,Clamped]),
	write_bnt_potential(Ns).
write_bnt_potential([(N,_,finite,_,Clamped,_,tabular(CPD))|Ns]) :- !,
	bnt_node(N,NN,_,_),
	format('CPD = reshape(~q,ns(family(bnet.dag,~d)));~n',[CPD,NN]),
	format('s   = 1:length(size(CPD));~n',[]),
	format('CPD = permute(CPD,[s(end) s(1:end-1)]);~n',[]),
	format('bnet.CPD{~d}=tabular_CPD(bnet,~d,''CPD'',CPD,''clamp'',~q);~n',[NN,NN,Clamped]),
	write_bnt_potential(Ns).


write_bnt_dag([]).
write_bnt_dag([(N,_,_,_,Pa,_)|Ns]) :-
	write_bnt_edges(N,Pa),
	write_bnt_dag(Ns).

write_bnt_edges(_,[]).
write_bnt_edges(N,[P|Ps]) :-
	bnt_node(N,NN,_,_),
	bnt_node(P,PN,_,_),
	format('dag(~q,~q)=1;~n',[PN, NN]),
	write_bnt_edges(N,Ps).

write_bnt_mapping([],_).
write_bnt_mapping([(N,Ref,_,_,_,_)|Ns],C) :-
	(bnt_node(_,E,Ref,_);E=C),
	assertz(bnt_node(N,C,Ref,E)),
	format('~@=~q;~n',[write_no_brackets(N),C]),
	NewC is C + 1,
	write_bnt_mapping(Ns,NewC). 

% ----------------------------------------------------------------------------
% Some auxilliary predicate definitions for Matlab
variablesCS([],[]).
variablesCS([Case|Cases],Var) :-
	evidence_variables(Case,VarC),
	variablesCS(Cases,VarCs),
	append(VarC,VarCs,VarU),
	sort(VarU,Var).


write_bnt_nth_delement(E,S) :-
	functor(E,P,NA),
	domain(P/NA,T,D),
	(T==discrete->
	    (nth(N,D,S),
	     write(N));
	    write(S)).

bnt_node_info([],[],[],[]).
bnt_node_info([(N,_,continuous,_,_)|Ns],[1|NS],DN,[E|Es]) :- !,
	bnt_node(N,_,_,E),
	bnt_node_info(Ns,NS,DN,Es).
bnt_node_info([(N,_,discrete,D,_,_)|Ns],[S|NS],[NN|DN],[E|Es]) :-
	length(D,S),
	bnt_node(N,NN,_,E),
	bnt_node_info(Ns,NS,DN,Es).
	

%-----------------------------------------------------------------------------
% Some auxilliary predicate definitions
%-----------------------------------------------------------------------------

%---------------------------------------------------------------------
% write the graphical structure of a solution graph
write_structure([]).
write_structure([N-PA-_|Rest]) :-
  format('~q <-- ~q~n',[N,PA]),
  write_structure(Rest).

%--------------------------------------------------------------------------
% building a list consisting of 1.0's (similar to matlab's ones but only a list/vector is generated)
ones(0,[]).
ones(1,[1.0]).
ones(N,[1.0|NL]) :-
  NewN is N - 1,
  ones(NewN,NL).

%--------------------------------------------------------------------------
% remove any brackets from an ground atom, e.g. a(t,z) atz
write_no_brackets(T) :-
	write_to_chars(T,C),
	delete(C,40,C1),	% if not Theta
	delete(C1,41,C2),	% if not Theta
%	delete(40,C,C1), %if Theta	
%	delete(41,C1,C2),%if Theta		
	substitute(44,C2,95,NT),
	name(N,NT),
	write(N).


%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% routines to compute an identifier from a prolog atom which
% can be used to identify the corresponding node within Netica
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
netica_equivalence(_, ClauseRef, E) :-
	netica_equivalence(ClauseRef,E),!.
netica_equivalence(NeticaID, ClauseRef, NeticaID) :-
	asserta(netica_equivalence(ClauseRef,NeticaID)).

%--------------------------------------------------------------------------
% Given a list of samples, i.e. a list of list of elements of the form netica_id=1
% compute the list of corresponding list of lists of prolog atoms.
prolog_id([],[]).
prolog_id([cpd(NA,C)|NR],[cpd(A,C)|R]) :- 
	netica_equivalence(A,NA),
	prolog_id(NR,R).
prolog_id([cpd(NA,C)|NR],[cpd(A,C)|R]) :- !,
	netica_equivalence(NA,A),
	prolog_id(NR,R).
prolog_id([HA='?'|HR],[A='?'|R]) :- !,
	netica_hash(A,HA),
	prolog_id(HR,R).
prolog_id([HA=HS|HR],[A=S|R]) :- !,
	netica_hash(A,HA),
	functor(A,P,NA),
	(domain(P/NA,finite,D)->
	    nth0(HS,D,S);
	    HS is S),
	prolog_id(HR,R).
prolog_id([HA|HR],[A|R]) :- !,
	prolog_id(HA,A),
	prolog_id(HR,R).
prolog_id(HA,A) :-
	netica_hash(A,HA).
%--------------------------------------------------------------------------
% netica identifyer <-> Prolog identifyer

netica_id([],[]).

%netica_id([(A,Ref,continuous,Domain,Clamped,Pa,CPD)|R],
%	  [(T,Equi,continuous,Domain,Clamped,NPa,NCPD)|NR]) :- !,
%	netica_id(R,NR),
%	netica_id(Pa,NPa),
%	netica_id(CPD,NCPD),
%	netica_identifier(A,T),
%	netica_equivalence(T,Ref,Equi).

netica_id([(A,Ref,Kind,Domain,Clamped,Pa,CPD)|R],
	  [(T,Equi,Kind,Domain,Clamped,NPa,CPD)|NR]) :- !,
	netica_id(R,NR),
	netica_id(Pa,NPa),
	netica_identifier(A,T),
	netica_equivalence(T,Ref,Equi).

netica_id([V='?'|R],[HV='?'|HR]) :- !,
	netica_id(R,HR),
	netica_identifier(V,HV).

netica_id([V=S|R],[HV=HS|HR]) :- !,
	netica_id(R,HR),
	functor(V,P,NA),
	domain(P/NA,T,D),
	((T=finite;T=discrete)->
	    nth0(HS,D,S);
	    HS is S),!,
	netica_identifier(V,HV).

%netica_id([normal(A,B)|R],[normal(HA,B)|HR]) :-
%	netica_id(R,HR),
%	netica_id(A,HA).
%netica_id(A+B,HA+HB) :-
%	netica_id(A,HA),
%	netica_id(B,HB).
%netica_id(A*B,HA*HB) :-
%	netica_id(A,HA),
%	netica_id(B,HB).

netica_id([V|R],[HV|HR]) :- !,
	netica_id(R,HR),
	netica_id(V,HV).
netica_id(A,A) :- 
	number(A),!.
netica_id(decomposed,-1) :- !.
netica_id(A,HA) :- 
	netica_identifier(A,HA),!.

netica_hash(1,1).

netica_identifier(A,T) :-
	netica_hash(A,T),!.
netica_identifier(A,T) :- % if A is a proposition we add p to it as identifier, eg. A=c -> T=pc (because of dot)
  functor(A,A,0),!,
  format_to_chars('~q',[A],C),	
  append([112],C,NT),
  atom_chars(T,NT),
  asserta(netica_hash(A,T)).

netica_identifier(A,T) :-	
	format_to_chars('~q',[A],C),
	delete(C,40,C1),	% if not Theta Klammer
	delete(C1,41,C2),	% if not Theta	Klammer
        delete(C2,91,C3),	% if not Theta
	delete(C3,93,C4), 
        delete(C4,45,C5),	% if not Theta
%	delete(40,C,C1), %if Theta	
%	delete(41,C1,C2),%if Theta	
	substitute(44,C5,95,NT),
	atom_chars(T,NT),
	asserta(netica_hash(A,T)).

%--------------------------------------------------------------------------
%------------------------------- only TclTk shell -------------------------------
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% routine to display the support network using Tcldot
display_dot(SN,QVariables,EVariables) :-
	tcl_interpreter(Interpr), 
	tcl_eval(Interpr,'destroy .blop.network.canvas',_), 
	tcl_eval(Interpr,'set c [canvas .blop.network.canvas -relief sunken -cursor crosshair \
		-xscrollcommand ".blop.network.h set" \
		-yscrollcommand ".blop.network.v set" \
		-borderwidth 0 -background white]',_), 
	tcl_eval(Interpr,'set g [dotnew digraph graph]',_),
	tcl_eval(Interpr,'$g setnodeattribute style filled color yellow',_), 
	tcl_eval(Interpr,'$g setedgeattribute style bold',_),
	display_dot_nodes(Interpr,SN,QVariables,EVariables),  
	display_dot_edges(Interpr,SN,1),  
	tcl_eval(Interpr,' $g layout',_),
	tcl_eval(Interpr,' eval [$g render]',_),
	tcl_eval(Interpr,'pack  .blop.network.v  -side right -fill both',_), 
	tcl_eval(Interpr,'pack  .blop.network.h  -side bottom -fill both',_), 
	tcl_eval(Interpr,'pack  .blop.network.canvas -side left -fill both -expand 1',_),   
	tcl_eval(Interpr,'$c configure -scrollregion [$c bbox all] ',_),
	tcl_eval(Interpr,' update',_).

display_dot_nodes(_,[],_,_).
display_dot_nodes(Interpr,[(N,decomposed,_,_,_,_,_)|Ns],Q,E) :-
	member(N,Q),!,
	netica_id(N,NN),
	tcl_eval(Interpr,
		 format('set ~w [$g addnode shape diamond style filled color red label {~w}]',[NN,N]),
		 _),
	display_dot_nodes(Interpr,Ns,Q,E).
display_dot_nodes(Interpr,[(N,decomposed,_,_,_,_,_)|Ns],Q,E) :-
	member(N=State,E),!,
	netica_id(N,NN),
	tcl_eval(Interpr,
		 format('set ~w [$g addnode shape diamond style filled color green label {~q=~q}]',[NN,N,State]),
		 _),
	display_dot_nodes(Interpr,Ns,Q,E).
display_dot_nodes(Interpr,[(N,decomposed,_,_,_,_,_)|Ns],Q,E) :-
	netica_id(N,NN),
	tcl_eval(Interpr,
		 format('set ~w [$g addnode shape diamond style filled color blue label {~q}]',[NN,N]),
		 _),
	display_dot_nodes(Interpr,Ns,Q,E).
display_dot_nodes(Interpr,[(N,_,_,_,_,_,_)|Ns],Q,E) :-
	member(N,Q),!,
	netica_id(N,NN),
	tcl_eval(Interpr,
		 format('set ~w [$g addnode shape box style filled color red label {~q}]',[NN,N]),
		 _),
	display_dot_nodes(Interpr,Ns,Q,E).
display_dot_nodes(Interpr,[(N,_,_,_,_,_,_)|Ns],Q,E) :-
	member(N=State,E),!,
	netica_id(N,NN),
	tcl_eval(Interpr,
		 format('set ~w [$g addnode shape box style filled color green label {~q=~q}]',[NN,N,State]),
		 _),
	display_dot_nodes(Interpr,Ns,Q,E).

display_dot_nodes(Interpr,[(N,_,_,_,_,_,_)|Ns],Q,E) :-
	netica_id(N,NN),
	tcl_eval(Interpr,
		 format('set ~w [$g addnode label {~q}]',[NN,N]),
		 _),
	display_dot_nodes(Interpr,Ns,Q,E).

display_dot_edges(_,[],_).
display_dot_edges(Interpr,[(N,_,_,_,_,Pa,_)|Ns],M) :-
	netica_id(N,NN),
 	display_dot_edges(Interpr,NN,Pa,M,NewM),
	display_dot_edges(Interpr,Ns,NewM).

display_dot_edges(_,_,[],M,M).
display_dot_edges(Interpr,N,[Pa|Pas],M,MM) :-
	netica_id(Pa,PPa),
	tcl_eval(Interpr, format('set e~d [$~q addedge $~w]',[M,PPa,N]),_), 
	NewM is M + 1,
	display_dot_edges(Interpr,N,Pas,NewM,MM).

%--------------------------------------------------------------------------
%------------------------------- only TclTk shell -------------------------------
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% some auxiliary definitions

write_support_network([]).
write_support_network([N|Ns]):-
  format('~q~n',[N]),
  write_support_network(Ns).


not(P) :- P,!,fail.
not(_) :- !.

decomp_rename(N,A,RA) :-
  A=..[Pred|Arg],
  decomp_rename_pred(N,Pred,RPred),
  RA=..[RPred|Arg].

decomp_rename_pred(N,Pred,RPred) :-
  write_to_chars(Pred,CPred),
  write_to_chars('_i',IPred),
  write_to_chars(N,CN),
  append(CPred,CN,Tmp),
  append(Tmp,IPred,CRPred),
  name(RPred,CRPred).

%--------------------------------------------------------------------------
%------------------------------- David -------------------------------
%--------------------------------------------------------------------------

:- dynamic tmp_fix/1.

 david:-	
  asserta(api(netica)),
  asserta(score_MaxIter(5)),
  asserta(score_Threshold(0.001)),
  asserta(score_Algorithm(em)),  
  retractall(data_cases(_)),
  retractall(netica_data_cases(_)),
  retractall(models(_)),
  retractall(top_theories(_)),
  retractall(ref(_,_,_)),
  retractall(cpd(_,_,_,_)),
  retractall(fix(_)), retractall(tmp_fix(_)),
  blop(lang_consult,'./blp_lang_files/blood.blp_lang'),
  format('Reading data cases from file ...~n',[]),
  read_samples_from_file('blop.blp_data',DataCases),   
%  asserta(data_cases(DataCases)),
  netica_id(DataCases,HDataCases),
  asserta(netica_data_cases(HDataCases)),
  format('done.~n',[]),
  format('Extracting (logical) models ...~n',[]),
  extract_models(DataCases,Models),
  asserta(models(Models)),
  blop_david_start,
  assert_refs.

assert_refs :-
  retractall(ref(_,_,_)),
  findall((H,B),cpd(H,B,Pa,CPDS),L),
  assert_refs(L,0).

assert_refs([],_).
assert_refs([(H,B)|R],N):-
  asserta(ref(H,B,N)),
   NewN is N + 1,
  assert_refs(R,NewN).

blop_david_start :-
  findall(P,(domain(P,_,_),\+fix(P)),Praed),
  Praed \=[], !,
  list_to_ord_set(Praed,Praedikates),
  length(Praedikates,PL),
  PL1 is PL - 1,
  findall((F,SMT,SMCPDs,SMLL),(sublist(F,Praedikates),length(F,PL1),
			      once(blop_david_single_praedikate(F,SMT,SMCPDs,SMLL))),L),
  get_maximum(L,MF,MT,MCPDs,MLL),
  ord_symdiff(Praedikates,MF,[LP]), 
  R is 10-PL, 
  david_assert_learned_theory(MT,R),
  david_assert_estimated_cpds(MCPDs),
  assert(fix(LP)),
  blop_david_start.

  blop_david_start :- !.

david_assert_learned_theory([],_).
david_assert_learned_theory([C|Cs],N) :-
  C = (H:-B),
  functor(H,P,NA),
  fix(P/NA),!,
  david_assert_learned_theory(Cs,N).

david_assert_learned_theory([C|Cs],N) :-
  assert((C)),
  C = (H:-B),
  assert(ref(H,B,N)),
  NewN is N + 1,
  david_assert_learned_theory(Cs,NewN).

david_assert_estimated_cpds([]).
david_assert_estimated_cpds([cpd((H:-_),CPD)|Xs]) :-
   functor(H,P,N),
  fix(P/N),!,
  david_assert_estimated_cpds(Xs).
david_assert_estimated_cpds([cpd((H:-true),CPD)|Xs]) :-
  retractall(cpd(H,B,[],_)),
  asserta(cpd(H,B,[],CPD)),
  david_assert_estimated_cpds(Xs).
david_assert_estimated_cpds([cpd((H:-B),CPD)|Xs]) :-
  conj_2_list(B,BL),
  retractall(cpd(H,B,BL,_)),
  asserta(cpd(H,B,BL,CPD)),
  david_assert_estimated_cpds(Xs).

  
get_maximum([(F,T,CPDs,LL)],F,T,CPDs,LL).
get_maximum([(F,T,CPDs,LL)|Rest],MF,MT,MCPDs,MLL) :-
  get_maximum(Rest,TF,TT,TCPDs,TLL),
  (LL<TLL->(MF=TF,MT=TT,MCPDs=TCPDs,MLL=TLL);
                 (MF=F,MT=T,MCPDs=CPDs,MLL=LL)).


blop_david_single_praedikate(F,SMT,SMCPDs,SMLL) :- 
  retractall(tmp_fix(_)),
  findall(_,(member(P,F),assert(tmp_fix(P))),_),
  blop_david(SMT,SMCPDs,SMLL).

blop_david(NewMT,NewCPDs,NewLL) :- 
  format('|-->Finding all top theories ... ',[]),
  fixed_definitions(F),
  models(Models),  
  findall(T,(blop_toptheory(T),blop_truetheory(T,Models)),TT),
  asserta(top_theories(TT)),
  findall(L,(member(M,TT),append(M,F,L)),TL),	  
  format('done.~n|-->Scoring all top theories...~n',[]), 
  maximally_scored_theory(TL,MT,CPDs,LL),   
  format('|-->done.~n|~n|-->Maximally scored top theory:~n|-->~q~n|-->Score: ~q~n',[MT,LL]),
  blop_david(MT,CPDs,LL,NewMT,NewCPDs,NewLL),   
  format('PROBABILISTIC SOLUTION scored ~q~n~q~n',[NewLL,NewMT]).  
 
	
blop_david(MT,CPDs,LL,NewMT,NewCPDs,NewLL) :-  
  format('|~n|-->Current hypothesis:~n|--> ~q~n|-->Score: ~q~n|~n|-->Refining...~n',[MT,LL]), 
  models(Models),
  findall(RT,(refinetheory(MT,RT),blop_truetheory(RT,Models)),RTL),
  maximally_scored_theory(RTL,NMT,NCPDs,NLL),   
  format('|~n|-->Maximally scored refined theory:~n|-->~q~n|-->Score: ~q~n|~n',[NMT,NLL]),
  (NLL>LL ->
   blop_david(NMT,NCPDs,NLL,NewMT,NewCPDs,NewLL);
   (NewMT=MT,NewLL=LL,NewCPDs=CPDs)).


%--------------------------------------------------------------------------
%------------------------------- tests -------------------------------
%--------------------------------------------------------------------------

test_blop_claudien :-
  blop_claudien_start('blood_praemble.blp','blop.blp_data',em,20,0.001,T,CPDs,Score),
  nl,write(T),nl,nl,write(CPDs),nl,write(Score),nl.

test_dbn(N):-
	cons_query(N,Q),!,
	query(Q,[],_),
	network(SN),
	netica_sample(SN,[],200,0,SL),
	tcl_write_samples_to_file(SL,'blop.blp_data',0).

cons_query(0,[r(0)]).
cons_query(N,[r(s(X)),r(X)|Rest]) :-
	NewN is N - 1,
	cons_query(NewN,[r(X)|Rest]).
	

% [blopconsole], ['blop_claudien/theta.pl'], test_blop_claudien.
%sample_training_examples('/usr/users/kriss/blop_tcltk/kdd_cup_2001/data/genes_relation2.blp_data',50,'/usr/users/kriss/blop_tcltk/kdd_cup_2001/data/genes_relation2.50.blp_data')
%sample_training_examples('./kddcup2001/data/prolog_db/local_test.blp_data',400,'./kddcup2001/data/prolog_db/local_test.400.blp_data')
sample_training_examples(InFile,Count,OutFile) :-
	read_samples_from_file(InFile,Seqs),
	length(Seqs,L),
	randset(Count,L,RIndex),
	rand_sample_training_examples(Seqs,RIndex,1,L,RSeqs,_),
	write_samples_to_file(RSeqs,OutFile).

sample_training_examples(InFile,Count,OutFile,ValFile) :-
	read_samples_from_file(InFile,Seqs),
	length(Seqs,L),
	randset(Count,L,RIndex),
	rand_sample_training_examples(Seqs,RIndex,1,L,RSeqs,ValSeqs),
	write_samples_to_file(RSeqs,OutFile),
	write_samples_to_file(ValSeqs,ValFile).

rand_sample_training_examples(_,_,L,L,[],[]).
rand_sample_training_examples([Seq|Seqs],[RI|RIs],RI,L,[Seq|RSeqs],ValSeqs) :- !,
	NewN is RI + 1,
	rand_sample_training_examples(Seqs,RIs,NewN,L,RSeqs,ValSeqs).
rand_sample_training_examples([Seq|Seqs],RIs,N,L,RSeqs,[Seq|ValSeqs]) :-
	NewN is N + 1,
	rand_sample_training_examples(Seqs,RIs,NewN,L,RSeqs,ValSeqs).


%  classify('./kddcup2001/data/prolog_db/local_test.blp_data').
classify(DataFile) :-
	read_samples_from_file(DataFile,Data),
	classify(Data,Results),
	length(Results,N),
	sum_list(Results,S),
	D is S/N,
	count_zeros(Results,ZN),
	A is ZN / N,
	write('Accuracy: '),write(A),nl,
	write('Average Dist.: '),write(D),nl. 

count_zeros([],0).
count_zeros([0|Rest],ZN) :- !,
	count_zeros(Rest,OZN),
	ZN is OZN + 1.
count_zeros([_|Rest],ZN) :-
	count_zeros(Rest,ZN).


classify([],[]).
classify([D|Ds],[R|Results]) :-
	classify(Ds,Results),
	classification(D,R).

classification([Q=S|Evd],R) :-
	query([Q],Evd,Marg),
	marg_to_array(Marg,0,AMarg),
	sort(AMarg,SMarg),
	reverse(SMarg,RMarg),
	find_class(RMarg,0,S,R),
	write(R),nl.


marg_to_array([P],N,[(P,N)]).
marg_to_array([P|Ps],N,[(P,N)|Marg]) :-
	NewN is N + 1,
	marg_to_array(Ps,NewN,Marg).

find_class([_],N,_,N).
find_class([(_,S)|_],N,S,N).
find_class([_|Rest],N,S,R) :-
	NewN is N + 1,
	find_class(Rest,NewN,S,R).	


accuracy([],N,K,A) :-
	A is K / N.
accuracy([R|Rs],N,K,A) :-
	(R==1->NewK is K + 1;NewK is K),
	accuracy(Rs,N,NewK,A).

				%
% test('./kddcup2001/data/prolog_db/local_test.blp_data',R).
test(DataFile,Results) :-
	read_samples_from_file(DataFile,Data),
	arrange_dataCases(Data,[],Results).

arrange_dataCases([],K,K).
arrange_dataCases([D|Ds],K,P) :-
	rvDC(D,VarD),
	member(VarD,K),!,
	arrange_dataCases(Ds,K,P).
arrange_dataCases([D|Ds],K,P) :-
	rvDC(D,VarD),
	arrange_dataCases(Ds,[VarD|K],P).
	

rvDC(Case,Var) :-
	evidence_variables(Case,VarC),
	sort(VarC,Var).
%read_samples_from_file('~/kddcup2001/prolog_db/training.862.ch.blp_data',[L]),findall(C,(member(chrom(_)=C,L)),LL),write(LL),sort(LL,SL),write(SL).
%----------------------------------------------------------
% test_localize('~/kddcup2001/learned/mi1_100.blp','~/kddcup2001/test/test_cases.blp_data').
%test_localize('~/kddcup2001/learned/m1_100.blp','~/kddcup2001/test/test_cases.blp_data'). %56.7
% test_localize('~/kddcup2001/learned/nb_ext4.blp','~/kddcup2001/test/test_cases.blp_data').
test_localize(Blp,DataFile) :-
	['~/kddcup2001/test/test_local'],
	read_samples_from_file(DataFile,[Data]),
	findall(local(G),local(G,_),LocalWO),
	sort(LocalWO,LocalWOS),
	findall(local(G)=L,local(G,L),Local),
	length(LocalWOS,NN),
	write('# tested genes: '), write(NN),nl,
	variablesCS([Data],VarS),
	append(LocalWOS,VarS,VarUS), 
	sort(VarUS,Var),
	length(Var,NV),
	write('# nodes: '),write(NV),nl,
	blop(consult,Blp),
	write('computing SN...'),nl,
	compute_support_network(Var,SN),
	write('done'),nl,
	write('computing identifier...'),nl,
	netica_id(LocalWOS,Nodes),
	netica_id(Local,Soll),
	netica_id(Data,HData),
	netica_id(SN,HSN),
	write('done'),nl,
	write('classifying...'),nl,
	blop_netica_eval(HSN,Nodes,HData,Marg,_),
	eval_marg(Soll,Marg,Results),
	length(Results,N),
	sum_list(Results,S),
	D is S/N,
	count_zeros(Results,ZN),
	A is ZN / N,nl,
	write('Accuracy: '),write(A),nl,
	write('Average Dist.: '),write(D),nl. 

eval_marg([],_,[]).
eval_marg([N=S|Solls],Margs,[R|Results]):-
	eval_marg(Solls,Margs,Results),
	member(marg(N,Marg),Margs),
	marg_to_array(Marg,0,AMarg),
	sort(AMarg,SMarg),
	reverse(SMarg,RMarg),
	find_class(RMarg,0,S,R),
	write(R),write(' ').
	


t_localize([],_,[],_).
t_localize([Gene|Genes],Model,[R|Results],HSN) :-
	t_localize(Genes,Model,Results,HSN),
	t_localization(Gene,Model,R,HSN).

t_localization(Q=S,HEvidence,R,HSN) :-
	netica_id(Q,HQ), 
	blop_netica_inference(HSN,[HQ],HEvidence,Marg,_),
	marg_to_array(Marg,0,AMarg),
	sort(AMarg,SMarg),
	reverse(SMarg,RMarg),
	find_class(RMarg,0,S,R),
	write(R),nl.

% localize('~/kddcup2001/prolog_db/training.100.blp_data').
localize(File) :-
	read_samples_from_file(File,[Data]),
	variablesCS([Data],VarUS),
	sort(VarUS,Var),
	compute_support_network(Var,SN),
	netica_id(SN,HSN),
	findall(local(G)=L,member(local(G)=L,Data),Genes),
	localize(Genes,Data,Results,HSN),
	length(Results,N),
	sum_list(Results,S),
	D is S/N,
	count_zeros(Results,ZN),
	A is ZN / N,nl,
	write('Accuracy: '),write(A),nl,
	write('Average Dist.: '),write(D),nl. 


localize([],_,[],_).
localize([Gene|Genes],Model,[R|Results],HSN) :-
	localize(Genes,Model,Results,HSN),
	localization(Gene,Model,R,HSN).

localization(Q=S,Model,R,HSN) :-
	select(Q=S,Model,Evidence),
	netica_id(Q,HQ), 
	netica_id(Evidence,HEvidence),
	blop_netica_inference(HSN,[HQ],HEvidence,Marg,_),
	marg_to_array(Marg,0,AMarg),
	sort(AMarg,SMarg),
	reverse(SMarg,RMarg),
	find_class(RMarg,0,S,R),
	write(R),write('  ').

%test_bongards('~/bongard/hendrik/bon3.blp','~/bongard/hendrik/bon1.blp_data').
test_bongards(Blp,DataFile) :- !,
	read_samples_from_file(DataFile,Data),
	variablesCS(Data,VarS),
	blop(consult,Blp),
	write('computing SN...'),nl,
	compute_support_network(VarS,SN),
	netica_id(Data,HData),
	netica_id(SN,HSN),!,
	write('done'),nl,
	write('classifying...'),nl,
	bongard(HData,Results,HSN).

bongard([],_,_).
bongard([C|Cs],[R|Results],HSN) :-
	bongard_test(C,R,HSN),
	bongard(Cs,Results,HSN).

bongard_test(D,R,HSN) :-
	select(pclass=S,D,Evidence),
	blop_netica_inference(HSN,[pclass],Evidence,Marg,_),
	marg_to_array(Marg,0,AMarg),
	sort(AMarg,SMarg),
	reverse(SMarg,RMarg),
	first(RMarg,(P,C)),
	find_class(RMarg,0,S,R),
	format('soll:  ~q  prob: ~q ist:  ~q  diff:  ~q~n',[C,P,S,R]).

first([A],A).
first([A|_],A).

real_test_bongards(Blp,DataFile) :- !,
	read_samples_from_file(DataFile,Data),
	blop(lang_consult,Blp),
	findall((H:-B),(cpd(H,B,_,_),B\==true),DB),
	real_bongard(DB,Data,Results).

real_bongard(_,[],_).
real_bongard(DB,[C|Cs],[R|Results]) :-
	real_bongard_test(DB,C,R),
	real_bongard(DB,Cs,Results).

real_bongard_test(IDB,D,R) :-
	retractall(netica_hash(_,_)),
	retractall(ref(_,_,_)),
	retractall(netica_equivalence(_,_)),
	retractall(invented(_)),
	variablesCS([D],VarS),
	assert_refs_theory(IDB,0),
	families(IDB,0,[VarS],[],BNtemp),
	roots([VarS],0,BNtemp,BNtmp),
	sort(BNtmp,BN),
	acyclic(BN),!,
	uniform_support_network(BN,SNC),
	apply_comb(SNC,SN),
	SN\==[],!,
	netica_id(D,HD),
	netica_id(SN,HSN),
	select(pclass=S,HD,Evidence),
	blop_netica_inference(HSN,[pclass],Evidence,Marg,_),
	marg_to_array(Marg,0,AMarg),
	sort(AMarg,SMarg),
	reverse(SMarg,RMarg),
	first(RMarg,(P,C)),
	find_class(RMarg,0,S,R),
	format('soll:  ~q  prob: ~q ist:  ~q  diff:  ~q~n',[C,P,S,R]).
